<template>
  <div id="app" :class="typeof weather.main != 'undefined' && weather.main.temp>16 ? 'warm' : 'cold' ">
    <div id="header">
        <h2>Weather</h2>
      </div>
    <main>
      <div class="search-box">
        <input type='text' 
        class="search-bar" 
        placeholder="Search location..."
        v-model="query"
        @keypress="fetchWeather"
        />
      </div>
      <div class="weather-wrap" v-if="typeof weather.main != 'undefined'" >
        <div class="location-box">
        <div class="location">{{ weather.name }}, {{ weather.sys.country }}</div>
        <div class="date">{{ dateBuilder() }}</div>
      </div>
      <div class="weather-box" >
        <div class="temp">{{ Math.round(weather.main.temp) }}°C</div>
        <div class="weather">{{ weather.weather[0].main }}</div>
      </div>
      <div class="weather-box" >
  
        <div class="humidity"><p>Humidity</p>{{ Math.round(weather.main.humidity) }}</div>
        <div class=" max-min-container">
          <div class="max-min-temp"><h4>Max Temp</h4>{{ Math.round(weather.main.temp_max) }}°C </div>
          <div class="max-min-temp"><h4>Min Temp</h4>{{ Math.round(weather.main.temp_min) }}°C </div>
        </div>
  
      </div>
      </div>
    </main>
  </div>
</template>

<script>


export default {
  name: 'App',
  
  data() {
    return {
      api_key: '6bbd8e3bd279eebaf24f0e56715cc98b',
      url_base: "https://api.openweathermap.org/data/2.5/",
      query: '',
      weather: {}
    }
  },
    methods: {
      fetchWeather (e) {
        if(e.key == "Enter")
        {
          fetch(`${this.url_base}weather?q=${this.query}&units=metric&APPID=${this.api_key}`)
          .then(res => {
            return res.json();
          }).then(this.setResults)
        }
      },
      setResults(results) {
        console.log("result-->",results)
      this.weather = results;
    },
    
      dateBuilder() {
        let d = new Date();
        console.log("d-->",d)
        let months = ["January", "February", "March", "April", "May",
        "June", "July", "August", "September", "October", "November", "December"];
        let days = ["Sunday"," Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"]
        let day = days[d.getDay()];
        let date = d.getDate();
        let month = months[d.getMonth()];
        let year = d.getFullYear();
        

        return `${day} ${date} ${month} ${year}`;
      }
    }
  }

</script>

<style>
  *{
    margin: 0;
    padding: 0;
    box-sizing: border-box;
  }

  #header{
    background-image: linear-gradient(to bottom, rgba(15, 18, 59, 0.25), rgba(0, 3, 10, 0.75));
    font-family: Arial, Helvetica, sans-serif;
    padding: 10px;
    color: seashell;
  }

  body{
    font-family: 'montserrat', sans-serif;
  }
  #app {
    background-image: url('./assets/cold.jpg');
    background-size: cover;
    background-position: bottom;
  }

  #app.warm{
        background-image: url('./assets/warm.jpg') !important;
        background-size: cover;
        background-position: bottom;
        background-size: 100%;
  }

  main {
    min-height: 100vh;
    padding: 25px;
    background-image: linear-gradient(to bottom, rgba(0,0,0,0.25), rgba(0,0,0,0.75));
  }
  .search-box{
    width: 100%;
    margin-bottom: 30px;
  }
  .search-box .search-bar {
    display : block;
    width: 100%;
    padding : 15px;
    color: black;
    font-size: 20px;
    appearance: none;
    border: none;
    outline: none;
    background: none;
    box-shadow: 0px 0px 16px rgba(0, 0, 0, 0.25);
    background-color: rgba(255, 255, 255, 0.5);
    border-radius: 0px 16px 0px 16px;
    transition: 0.4s;
  }

  .search-box .search-bar:focus{
    background-color:rgba(255, 255, 255, 0.75);
    border-radius: 16px 0px 16px 0px;
  }

  .location-box .location{
    color:snow;
    font-size: 32px;
    font-weight: 500;
    text-align: center;
    text-shadow: 1px 3px rgba(0,0,0,0.25);
  }

  .location-box .date{
    color:snow;
    font-size: 20px;
    font-weight: 300;
    text-align: center;
    font-style: italic;
  }
  .weather-box {
    text-align: center;
  }

  .weather-box .temp {
    display: inline-block;
    padding: 10px 25px;
    color: #FFF;
    font-size: 102px;
    font-weight: 900;
    text-shadow: 3px 6px rgba(255, 255, 255, 0.35);
    border-radius: 16px;
    margin: 30px 0px;
    box-shadow: 3px 6px rgba(0, 0, 0, 0.5);
    background-color: rgba(255, 255, 255, 0.25);
  }

  .weather-box .weather {
    color: #FFFF;
    font-size: 48px;
    font-weight: 700;
    font-style: italic;
    text-shadow: 3px 6px rgba(0, 0, 0, 0.25);
  }

  .weather-box .humidity {
    display: inline-block;
    padding: 10px 25px;
    color: #FFF;
    font-size: 40px;
    font-weight: 900;
    text-shadow: 1px 3px rgba(255, 255, 255, 0.35);
    border-radius: 16px;
    margin: 30px 0px;
    box-shadow: 3px 6px rgba(0, 0, 0, 0.5);
    background-color: rgba(255, 255, 255, 0.25);
  }

  .max-min-container{
    display: flex;
    justify-content: space-around;
  }
  .max-min-temp {
    color:seashell;
    font-size: 25px;
  }
</style>
